freeslot("S_STOMP_LAND", "S_STOMP_THOK_POUND", "MT_STOMP_DAMAGEPARTICLE", "S_STOMP_DAMAGEPARTICLE", "S_STOMP_SPLASHATTACK")

states[S_STOMP_SPLASHATTACK] = {SPR_STAB, A|FF_FULLBRIGHT|FF_FLOORSPRITE, 14, nil, 6, 2, S_NULL}

states[S_STOMP_THOK_POUND] = {
        sprite = SPR_PLAY,
        frame = SPR2_ROLL|FF_ANIMATE,
        tics = -1,
        var1 = 2,
        var2 = 1,
        nextstate = S_STOMP_THOK_POUND
}

states[S_STOMP_LAND] = {
        sprite = SPR_PLAY,
        frame = SPR2_LAND,
        tics = 25,
        nextstate = S_PLAY_WALK
}

addHook("PlayerThink", function(player)
	if not (player.mo and player.mo.valid) then return end
	
	if player.mo.state == S_STOMP_LAND
		player.powers[pw_nocontrol] = 2
		player.mo.momx = 0
		player.mo.momy = 0
	end
	if player.mo.state == S_STOMP_THOK_POUND
		player.panim = PA_DASH
		player.powers[pw_nocontrol] = 2
		player.mo.momx = 0
		player.mo.momy = 0
		local ofsts_tics = min(TICRATE, leveltime)
		local ofsts = FixedMul((ofsts_tics * FRACUNIT) / TICRATE, FRACUNIT*2)
		local f = FixedMul(2*player.mo.scale, sin(FixedAngle(P_RandomRange(180, 360)*FRACUNIT)))
		local ka = P_SpawnGhostMobj(player.mo)
		if leveltime % 5 == 0
			ka.color = player.mo.color
			ka.colorized = true
			ka.fuse = 5
		else
			ka.blendmode = AST_ADD
			ka.color = player.mo.color
			ka.fuse = 3
		end
		P_SetObjectMomZ(player.mo, -40*FRACUNIT, false)
		ka.height = player.mo.height
		ka.angle = player.drawangle
		ka.target = player.mo
		ka.flags2 = player.mo.flags2
		ka.spritexoffset = ofsts * (((leveltime%4) >= 2) and -1 or 1)
		P_MoveOrigin(ka, player.mo.x + f, player.mo.y + f, player.mo.z)
		if P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR
			S_StartSound(player.mo, sfx_s3k4c)
			S_StartSound(player.mo, sfx_s1cb)
			S_StartSound(player.mo, sfx_rocks1)
			for i = 1,18
				local wind = P_SPMAngle(player.mo,MT_STOMP_DAMAGEPARTICLE,player.mo.angle+(ANG20*i),1)
				wind.target = player.mo
				wind.momz = 0
				wind.momy = 0
				wind.momx = 0
				wind.tics = 17
				P_InstaThrust(wind,wind.angle,10*FRACUNIT)
			end
			local thok = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
			if thok and thok.valid
				thok.state = S_STOMP_SPLASHATTACK
				thok.color = player.mo.color
				thok.colorized = true
				thok.blendmode = AST_ADD
				thok.scale = player.mo.scale*2
				thok.destscale = player.mo.scale*8
				//Spawn the rock's missiles!
				for i = 1, 9
					local rock = P_SpawnMobjFromMobj(thok, 0, 0, 0, MT_THOK) //Double thok, lol
					if rock and rock.valid
						rock.scale = player.mo.scale/2
						rock.angle = ANGLE_45*i
						rock.state = S_ROCKCRUMBLEA
						P_InstaThrust(rock, rock.angle, 2*FRACUNIT)
						P_SetObjectMomZ(rock, 8*FRACUNIT)
						rock.flags = $1 & ~MF_NOGRAVITY
						rock.fuse = TICRATE
					end
				end
			end
			if player == consoleplayer
				P_StartQuake(10*FRACUNIT, 5)
			end
			player.mo.state = S_STOMP_LAND
		end
	end
end)

rawset(_G, "CheckPlayer", function(m1, m2,bruh)
	if m1 and m1.valid and m2 and m2.valid and m1.player and m1.player.valid and m2.player and m2.player.valid
		local p1 = m1.player
		local p2 = m2.player
		if (gametyperules & GTR_TEAMS)
			if cv_friendlyfire.value or (gametyperules & GTR_FRIENDLYFIRE)
				return false
			else
				if p1.ctfteam and p2.ctfteam and p1.ctfteam == p2.ctfteam
					return true
				else
					return false
				end
			end
		else
			if not G_CoopGametype()
				return false
			else
				if cv_friendlyfire.value >= 1
					return false
				else
					return true
				end
			end
		end
	end
	return false
end)

addHook("TouchSpecial", function(galaxy, mo)
	if not (galaxy and galaxy.valid) then return end
	if not (galaxy.target and galaxy.target.valid and galaxy.target.player) then return end
	local target = galaxy.target
	local p = mo.player
	if (target == mo) or (CBW_Battle and CheckPlayer(target.player, p)) return true end
	if (CBW_Battle)
		if not (p.guard)
			if not G_GametypeHasTeams() or not (target.player.ctfteam == p.ctfteam and target ~= mo) then
				galaxy.tracer = mo
				local angle = R_PointToAngle2(target.x, target.y, mo.x, mo.y)
				P_SetObjectMomZ(mo, 4*FRACUNIT)
				CBW_Battle.DoPlayerTumble(mo.player, 2*TICRATE, angle, FixedMul(mo.scale, FRACUNIT), true)
				//mo.debaff = example*TICRATE
				P_RemoveMobj(galaxy)
			end
		end
	end
	return true
end, MT_STOMP_DAMAGEPARTICLE)

local BattleFuncSet = false

addHook("ThinkFrame",function()
	if (BattleFuncSet) or not(CBW_Battle and CBW_Battle.SkinVars) then return end
		BattleFuncSet = true
		local GalaxyPriority = function(player)
			if player.mo.state == S_STOMP_THOK_POUND
				CBW_Battle.SetPriority(player,1,2,nil,1,2,"Gravity Smash")
			end
			if player.mo.state == S_STOMP_LAND
				CBW_Battle.SetPriority(player,15,0,nil,15,0,"Gravity Smash Ground")
			end
		end
		//Battle Mode
		local GalaxyBattle = function(mo,doaction,pressedaction)
			local player = mo.player
			if example 
				player.canguard = false
			end
			if P_IsObjectOnGround(mo)
				player.actiontext = "Gravity Pulse"
				player.actionrings = 10
			else
				player.actiontext = "Gravity Smash"
				player.actionrings = 10
			end
			if player.actionstate != 0
				player.canguard = false
			end
			if player.actionstate == 0
			and (player.mo.state != S_STOMP_THOK_POUND or player.mo.state != S_STOMP_LAND or player.mo.state != S_PLAY_SUPER_TRANS1)
				if doaction == 1
					if P_IsObjectOnGround(mo)
						player.pflags = $1 & ~(PF_SPINNING|PF_JUMPED|PF_THOKKED)
						for i = 1,18
							local wind = P_SPMAngle(player.mo,MT_STOMP_DAMAGEPARTICLE,player.mo.angle+(ANG20*i),1)
							wind.target = player.mo
							wind.momz = 0
							wind.momy = 0
							wind.momx = 0
							wind.tics = 17
							P_InstaThrust(wind,wind.angle,10*FRACUNIT)
						end
						local thok = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
						if thok and thok.valid
							thok.state = S_STOMP_SPLASHATTACK
							thok.color = player.mo.color
							thok.colorized = true
							thok.blendmode = AST_ADD
							thok.scale = player.mo.scale*2
							thok.destscale = player.mo.scale*8
						end
						CBW_Battle.PayRings(player)
						mo.state = S_PLAY_SUPER_TRANS1
						CBW_Battle.ApplyCooldown(player,TICRATE*4+15)
					else
						player.pflags = $1 & ~(PF_SPINNING|PF_JUMPED|PF_THOKKED)
						S_StartSound(player.mo, sfx_s3k9a)
						S_StartSound(player.mo, sfx_s3k42)
						S_StartSound(player.mo, sfx_spin)
						P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
						player.mo.state = S_STOMP_THOK_POUND
						player.mo.exetiorpnd_cdwn = 5*TICRATE
						CBW_Battle.PayRings(player)
						CBW_Battle.ApplyCooldown(player,TICRATE*4+15) 
					end
				end
			end
		end
	CBW_Battle.SkinVars["gsonic"] = {
		weight = 100,
		special = GalaxyBattle,
		func_priority_ext = GalaxyPriority
	}
	print("test")
end)